

# ListDetectorModelVersions
<a name="API_ListDetectorModelVersions"></a>

**Important**  
End of support notice: On May 20,2026, Amazon will end support for Amazon IoT Events. After May 20,2026, you will no longer be able to access the Amazon IoT Events console or Amazon IoT Events resources. For more information, see [Amazon IoT Events end of support](https://docs.amazonaws.cn/iotevents/latest/developerguide/iotevents-end-of-support.html). 

Lists all the versions of a detector model. Only the metadata associated with each detector model version is returned.

## Request Syntax
<a name="API_ListDetectorModelVersions_RequestSyntax"></a>

```
GET /detector-models/detectorModelName/versions?maxResults=maxResults&nextToken=nextToken HTTP/1.1
```

## URI Request Parameters
<a name="API_ListDetectorModelVersions_RequestParameters"></a>

The request uses the following URI parameters.

 ** [detectorModelName](#API_ListDetectorModelVersions_RequestSyntax) **   <a name="iotevents-ListDetectorModelVersions-request-uri-detectorModelName"></a>
The name of the detector model whose versions are returned.  
Length Constraints: Minimum length of 1. Maximum length of 128.  
Pattern: `^[a-zA-Z0-9_-]+$`   
Required: Yes

 ** [maxResults](#API_ListDetectorModelVersions_RequestSyntax) **   <a name="iotevents-ListDetectorModelVersions-request-uri-maxResults"></a>
The maximum number of results to be returned per request.  
Valid Range: Minimum value of 1. Maximum value of 250.

 ** [nextToken](#API_ListDetectorModelVersions_RequestSyntax) **   <a name="iotevents-ListDetectorModelVersions-request-uri-nextToken"></a>
The token that you can use to return the next set of results.

## Request Body
<a name="API_ListDetectorModelVersions_RequestBody"></a>

The request does not have a request body.

## Response Syntax
<a name="API_ListDetectorModelVersions_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "detectorModelVersionSummaries": [ 
      { 
         "creationTime": number,
         "detectorModelArn": "string",
         "detectorModelName": "string",
         "detectorModelVersion": "string",
         "evaluationMethod": "string",
         "lastUpdateTime": number,
         "roleArn": "string",
         "status": "string"
      }
   ],
   "nextToken": "string"
}
```

## Response Elements
<a name="API_ListDetectorModelVersions_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [detectorModelVersionSummaries](#API_ListDetectorModelVersions_ResponseSyntax) **   <a name="iotevents-ListDetectorModelVersions-response-detectorModelVersionSummaries"></a>
Summary information about the detector model versions.  
Type: Array of [DetectorModelVersionSummary](API_DetectorModelVersionSummary.md) objects

 ** [nextToken](#API_ListDetectorModelVersions_ResponseSyntax) **   <a name="iotevents-ListDetectorModelVersions-response-nextToken"></a>
The token that you can use to return the next set of results, or `null` if there are no more results.  
Type: String

## Errors
<a name="API_ListDetectorModelVersions_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** InternalFailureException **   
An internal failure occurred.    
 ** message **   
The message for the exception.
HTTP Status Code: 500

 ** InvalidRequestException **   
The request was invalid.    
 ** message **   
The message for the exception.
HTTP Status Code: 400

 ** ResourceNotFoundException **   
The resource was not found.    
 ** message **   
The message for the exception.
HTTP Status Code: 404

 ** ServiceUnavailableException **   
The service is currently unavailable.    
 ** message **   
The message for the exception.
HTTP Status Code: 503

 ** ThrottlingException **   
The request could not be completed due to throttling.    
 ** message **   
The message for the exception.
HTTP Status Code: 429

## See Also
<a name="API_ListDetectorModelVersions_SeeAlso"></a>

For more information about using this API in one of the language-specific Amazon SDKs, see the following:
+  [Amazon Command Line Interface V2](https://docs.amazonaws.cn/goto/cli2/iotevents-2018-07-27/ListDetectorModelVersions) 
+  [Amazon SDK for .NET V4](https://docs.amazonaws.cn/goto/DotNetSDKV4/iotevents-2018-07-27/ListDetectorModelVersions) 
+  [Amazon SDK for C\$1\$1](https://docs.amazonaws.cn/goto/SdkForCpp/iotevents-2018-07-27/ListDetectorModelVersions) 
+  [Amazon SDK for Go v2](https://docs.amazonaws.cn/goto/SdkForGoV2/iotevents-2018-07-27/ListDetectorModelVersions) 
+  [Amazon SDK for Java V2](https://docs.amazonaws.cn/goto/SdkForJavaV2/iotevents-2018-07-27/ListDetectorModelVersions) 
+  [Amazon SDK for JavaScript V3](https://docs.amazonaws.cn/goto/SdkForJavaScriptV3/iotevents-2018-07-27/ListDetectorModelVersions) 
+  [Amazon SDK for Kotlin](https://docs.amazonaws.cn/goto/SdkForKotlin/iotevents-2018-07-27/ListDetectorModelVersions) 
+  [Amazon SDK for PHP V3](https://docs.amazonaws.cn/goto/SdkForPHPV3/iotevents-2018-07-27/ListDetectorModelVersions) 
+  [Amazon SDK for Python](https://docs.amazonaws.cn/goto/boto3/iotevents-2018-07-27/ListDetectorModelVersions) 
+  [Amazon SDK for Ruby V3](https://docs.amazonaws.cn/goto/SdkForRubyV3/iotevents-2018-07-27/ListDetectorModelVersions) 